using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Collections;

namespace Utils.Misc
{
    /// <summary>
    /// Contains an array with all the colors
    /// </summary>
    public class Colors : IEnumerator
    {
        #region Variables
        private static Color[] vColor = new Color[]
        {
            #region Colors
            Color.AliceBlue,
			Color.AntiqueWhite,
			Color.Aqua,
			Color.Aquamarine,
			Color.Azure,
			Color.Beige,
			Color.Bisque,
			Color.Black,
			Color.BlanchedAlmond,
			Color.Blue,
			Color.BlueViolet,
			Color.Brown,
			Color.BurlyWood,
			Color.CadetBlue,
			Color.Chartreuse,
			Color.Chocolate,
			Color.Coral,
			Color.CornflowerBlue,
			Color.Cornsilk,
			Color.Crimson,
			Color.Cyan,
			Color.DarkBlue,
			Color.DarkCyan,
			Color.DarkGoldenrod,
			Color.DarkGray,
			Color.DarkGreen,
			Color.DarkKhaki,
			Color.DarkMagenta,
			Color.DarkOliveGreen,
			Color.DarkOrange,
			Color.DarkOrchid,
			Color.DarkRed,
			Color.DarkSalmon,
			Color.DarkSeaGreen,
			Color.DarkSlateBlue,
			Color.DarkSlateGray,
			Color.DarkTurquoise,
			Color.DarkViolet,
			Color.DeepPink,
			Color.DeepSkyBlue,
			Color.DimGray,
			Color.DodgerBlue,
			Color.Firebrick,
			Color.FloralWhite,
			Color.ForestGreen,
			Color.Fuchsia,
			Color.Gainsboro,
			Color.GhostWhite,
			Color.Gold,
			Color.Goldenrod,
			Color.Gray,
			Color.Green,
			Color.GreenYellow,
			Color.Honeydew,
			Color.HotPink,
			Color.IndianRed,
			Color.Indigo,
			Color.Ivory,
			Color.Khaki,
			Color.Lavender,
			Color.LavenderBlush,
			Color.LawnGreen,
			Color.LemonChiffon,
			Color.LightBlue,
			Color.LightCoral,
			Color.LightCyan,
			Color.LightGoldenrodYellow,
			Color.LightGray,
			Color.LightGreen,
			Color.LightPink,
			Color.LightSalmon,
			Color.LightSeaGreen,
			Color.LightSkyBlue,
			Color.LightSlateGray,
			Color.LightSteelBlue,
			Color.LightYellow,
			Color.Lime,
			Color.LimeGreen,
			Color.Linen,
			Color.Magenta,
			Color.Maroon,
			Color.MediumAquamarine,
			Color.MediumBlue,
			Color.MediumOrchid,
			Color.MediumPurple,
			Color.MediumSeaGreen,
			Color.MediumSlateBlue,
			Color.MediumSpringGreen,
			Color.MediumTurquoise,
			Color.MediumVioletRed,
			Color.MidnightBlue,
			Color.MintCream,
			Color.MistyRose,
			Color.Moccasin,
			Color.NavajoWhite,
			Color.Navy,
			Color.OldLace,
			Color.Olive,
			Color.OliveDrab,
			Color.Orange,
			Color.OrangeRed,
			Color.Orchid,
			Color.PaleGoldenrod,
			Color.PaleGreen,
			Color.PaleTurquoise,
			Color.PaleVioletRed,
			Color.PapayaWhip,
			Color.PeachPuff,
			Color.Peru,
			Color.Pink,
			Color.Plum,
			Color.PowderBlue,
			Color.Purple,
			Color.Red,
			Color.RosyBrown,
			Color.RoyalBlue,
			Color.SaddleBrown,
			Color.Salmon,
			Color.SandyBrown,
			Color.SeaGreen,
			Color.SeaShell,
			Color.Sienna,
			Color.Silver,
			Color.SkyBlue,
			Color.SlateBlue,
			Color.SlateGray,
			Color.Snow,
			Color.SpringGreen,
			Color.SteelBlue,
			Color.Tan,
			Color.Teal,
			Color.Thistle,
			Color.Tomato,
			Color.Transparent,
			Color.Turquoise,
			Color.Violet,
			Color.Wheat,
			Color.White,
			Color.WhiteSmoke,
			Color.Yellow,
			Color.YellowGreen
#endregion
		};
        private int vIndex = -1;
        #endregion

        #region Properties
        /// <summary>
        /// Return the indexed color from the array
        /// </summary>
        /// <param name="i">Index in the array</param>
        /// <returns></returns>
        public Color this[int i]
        {
            get { return vColor[i]; }
            set { vColor[i] = value; }
        }
        /// <summary>
        /// Gets the array with the colors
        /// </summary>
        public Color[] Items { get { return vColor; } }
        #endregion

        #region Methods
        /// <summary>
        /// Gets the index of the indicated Color
        /// </summary>
        /// <param name="_Color">The methods looks for the index of this color</param>
        /// <returns>The index of this Color or -1 if not find</returns>
        public int IndexOf(Color _Color)
        {
            for (int i = 0; i < vColor.Length; i++)
            {
                if (vColor[i] == _Color)
                    return i;
            }
            return -1;
        }
        /// <summary>
        /// Gets the index of the indicated Color
        /// </summary>
        /// <param name="_Color">The methods looks for the index of this color</param>
        /// <returns>The index of this Color or -1 if not find</returns>
        public int IndexOf(string _Color)
        {
            for (int i = 0; i < vColor.Length; i++)
            {
                if (vColor[i].ToString() == _Color)
                    return i;
            }
            return -1;
        }
        #endregion

        #region Operators
        /// <summary>
        /// Convert the Colors into an array of Color
        /// </summary>
        /// <param name="_Colors">the objet to convert</param>
        /// <returns>the array of color</returns>
        public static implicit operator Color[](Colors _Colors) { return vColor; }
        #endregion

        #region IEnumerator Members
        /// <summary>
        /// Return the current element
        /// </summary>
        public object Current { get { return vColor[vIndex]; } }
        /// <summary>
        /// Move to the next element
        /// </summary>
        /// <returns></returns>
        public bool MoveNext() { return ++vIndex < vColor.Length; }
        /// <summary>
        /// Reset the enumerator
        /// </summary>
        public void Reset() { vIndex = -1; }
        /// <summary>
        /// Gets the enumerator
        /// </summary>
        /// <returns>return this</returns>
        public IEnumerator GetEnumerator() { vIndex = -1; return this; }
        #endregion
    }
}
